#ifndef __INotify_h__
# define __INotify_h__

#include "includes"
#include "Socket.h"

namespace core {
   
   class INotify : Socket {
      
    public:
      INotify(EPoll &ePoll);
      ~INotify();
      
      int addWatch(std::string watch);
      void removeWatch(int wd);

      void onDataReceived(char *buffer, int len) override;      

      virtual void inAccess(std::string name) {}      
      virtual void inAttrib(std::string name) {}      
      virtual void inCloseWrite(std::string name) {}
      virtual void inCloseNoWrite(std::string name) {}
      virtual void inCreate(std::string name) {} 
      virtual void inDelete(std::string name) {} 
      virtual void inDeleteSelf(std::string name) {} 
      virtual void inModify(std::string name) {} 
      virtual void inMoveSelf(std::string name) {} 
      virtual void inMovedFrom(std::string name) {} 
      virtual void inMovedTo(std::string name) {} 
      virtual void inOpen(std::string name) {} 
      
   };
   
}

#endif
